var Est45500_ManutencaoDoLote_Controller = function(templateManager, ScreenService, General, ZhFilterPreferences){

    this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
    
    this.setStripeData = function(widget) {
        var currentRow = widget.appliedFilter.FILTER_ROW;
        currentRow.DTENTRLOTE = (currentRow.DTENTRLOTE) ? currentRow.DTENTRLOTE : {'start': '', 'end': ''};
        var stripeWidget = templateManager.container.getWidget("stripe");

        stripeWidget.currentRow = {};
        stripeWidget.currentRow.NMFILIAL   = currentRow.CDFILIAL + ' - ' + currentRow.NMFILIAL;
        stripeWidget.currentRow.NMPRODUTO   = currentRow.CDARVPROD + ' - ' + currentRow.NMPRODUTO;
        stripeWidget.currentRow.DTENTRLOTE = 'De ' + currentRow.DTENTRLOTE.start + ' até ' + currentRow.DTENTRLOTE.end;
    };
    
    this.getFieldValueFilter = function(filedName, widgetName) {
        var container =  templateManager.container;
        if(container) {
            var filterWidget;
            var filterBforeApply = templateManager.container.getActiveWidget();
            if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
              filterWidget = filterBforeApply;
            else {
                var f = container.getWidget(widgetName);
                if(f) {
                     filterWidget = container.getWidget(widgetName).appliedFilter;
                }
               
            }
            
            if(filterWidget) {
                var valueField;
                if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[filedName];
                else
                    valueField = filterWidget.FILTER_ROW[filedName];
                    
                return valueField || null;
            }
            else return null;
        }
        else return null;
    };
    
    this.openFilter = function(widget){
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            rowsToSet.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            ZhFilterPreferences.setOriginalFilter(widget.id, rowsToSet);
            ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
        });
    };
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
    
    this.reloadIfEmpty = function(field){
        if(field.dataSource.data.length == 0)
            field.reload();
    };
    
    this.saveData = function(widget){
        if(datasValidas(widget)){
            General.saveCrud(widget).then(sucess => {
                widget.list();
                widget.reload();
            });  
        }
    };
    
    var datasValidas = function(widget){
        let dataset = widget.dataSource.data;
        let valido = true;
        let arrDataFields = ['DTVALILOTE', 'DTENTRLOTE', 'DTFABRPROD'];
        dataset = dataset.filter(row => row.changed);
        dataset.forEach(row => {
            arrDataFields.forEach(param => {
                if(!row[param]){
                    ScreenService.showMessage('O campo '+widget.getField(param).label+' do lote '+row.NRLOTEESTQ+' deve ser informado');
                    valido = false;
                }
            });
            
            if(moment(row.DTENTRLOTE,'DD/MM/YYYY').isAfter(moment(row.DTVALILOTE,'DD/MM/YYYY'))){
                ScreenService.showMessage('Data de entrada do lote '+row.NRLOTEESTQ+' deve ser menor ou igual a data de validade.');
                valido = false;
            }
                
            if(moment(row.DTFABRPROD,'DD/MM/YYYY').isAfter(moment(row.DTVALILOTE,'DD/MM/YYYY'))){
                ScreenService.showMessage('Data de fabricação do lote '+row.NRLOTEESTQ+' deve ser menor ou igual a data de validade.');
                valido = false;
            }
            
        });
        return valido;
    };
    
    this.cancelInlineEdit = function(widget) {
        // TODO criar função para desmarcar linhas editadas
        // GerUtil.desmarcaLinhasEditadas(lancamentoEncargoWidget, CANCELAR);
        widget.dataSource.data.forEach(row => {
            Object.keys(row).forEach(function (key) {
                if(key.indexOf('changed_') > -1){
                    widget.currentRow[key.replace('changed_','')] = row[key];
                    delete widget.currentRow[key];
                }
            });
            delete widget.currentRow.changed;
        });
        widget.list();
    };
    
    this.validaFilial = function(widget, fieldName) {
        /*
        var cdfilial =  widget.currentRow.CDFILIAL;
        if(cdfilial) {
            var filter = [
                {
                    "name":"CDFILIAL",
                    "operator":"=",
                    "value": cdfilial
                }
            ];
            
            General.callRestEngine('est_ajuste#/crud/paramfilial', 'FilterData', filter).then(function(success){
                widget.currentRow.DTPROCESSA = success.dataset.paramfilial[0].DTPROCESSA;
                widget.currentRow.controlaLote = success.dataset.paramfilial[0].IDUTILLOTE;
                if(success.dataset.paramfilial[0].IDCTRLESTQ === 'S') {
                    if(success.dataset.paramfilial[0].IDUTILALMOX === 'S') {
                        if(fieldName === 'NMFILIALDEST') {
                            widget.getField('DSALMOXARIFEDEST').readOnly = false;
                            if(success.dataset.paramfilial[0].IDUTILLCESTQ == 'S') {
                                widget.currentRow.controlaLocalDest = true;
                            }
                            else {
                                widget.currentRow.controlaLocalDest = false;
                            }
                        }
                        else {
                            widget.getField('DSALMOXARIFE').readOnly = false;
                            if(success.dataset.paramfilial[0].IDUTILLCESTQ == 'S') {
                                widget.currentRow.controlaLocal = true;
                            }
                            else {
                                widget.currentRow.controlaLocal = false;
                            }
                        }
                        widget.getField('DSALMOXARIFE').dataSourceFilter.forEach(function(fil){
                            if(fil.name == "CDFILIAL"){
                                fil.value = widget.currentRow.CDFILIAL;
                            }
                        });
                        widget.getField('DSALMOXARIFE').reload();
                    }
                    else {
                        if(fieldName === 'NMFILIALDEST') {
                            widget.getField('DSALMOXARIFEDEST').readOnly = true;
                            widget.getField('DSLOCALESTOQDEST').readOnly = true;    
                        }
                        else {
                            ScreenService.showMessage(mensagens.controlaAlmoxarifado);
                            widget.getField('DSALMOXARIFE').readOnly = true;
                            widget.getField('DSLOCALESTOQ').readOnly = true;
                        }
                    }
                }
                else {
                    if(fieldName === 'NMFILIALDEST') {
                        widget.currentRow.CDFILIALDEST = '';
                        widget.currentRow.NMFILIALDEST = '';
                        ScreenService.showMessage(mensagens.controlaEstoque);
                        widget.currentRow.controlaLocalDest = false;
                    }
                    else {
                        widget.currentRow.CDFILIAL = '';
                        widget.currentRow.NMFILIAL = '';
                        widget.currentRow.controlaLocal = false;
                    }
                }
            });
        }
        else {
            widget.getField('DSALMOXARIFE').readOnly = true;
            widget.getField('DSLOCALESTOQ').readOnly = true;
        }
        widget.currentRow.CDALMOXARIFE = '';
        widget.currentRow.DSALMOXARIFE = '';
        widget.currentRow.CDLOCALESTOQ = '';
        widget.currentRow.DSLOCALESTOQ = '';
        */
	};


};
Configuration(function (ContextRegister){
    ContextRegister.register('Est45500_ManutencaoDoLote_Controller', Est45500_ManutencaoDoLote_Controller);
});
