function Est70000_ResumoDeOperacoes_Controller(General, ZhLayoutPreferences, metaDataFactory, ScreenService, EstUtil, ZhFilterPreferences, templateManager, Est70000_ResumoDeOperacoes_Service) {

    let IDUTILALMOX, IDUTILLCESTQ;

    this.onOpenFilter = function(widget) {
        let rowsToSet = {};
        const actualDate = getLocalVar('DTPROCESSA');

        rowsToSet.INTERVALO = { "start": actualDate, "end": actualDate, "formattedStart": actualDate, "formattedEnd": actualDate };
        rowsToSet.NMFILIAL = getLocalVar('NMFILIAL');
        rowsToSet.CDFILIAL = getLocalVar('CDFILIAL');

        ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(success => {
            const filterWidget = templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions');

            filterWidget.getField('NMFILIAL').reload().then(_ => {
                this.onChangeUnity(filterWidget);
            });
        });
    };

    this.onManageFilterParams = function(widget) {
        widget.dataSourceFilter.pop();
        this.clearResults(widget);
        widget.reload();
    };

    this.onChangeUnity = function(widget) {
        Est70000_ResumoDeOperacoes_Service.getUnityInfo(widget.currentRow.CDFILIAL).then(data => {
            const {
                IDUTILALMOX: CTRLALMOX,
                IDUTILLCESTQ: CTRLLOCAL
            } = data.dataset.paramfilial[0];
            const almoxField = widget.getField('DSALMOXARIFE');
            const LocalField = widget.getField('DSLOCALESTOQ');

            IDUTILALMOX = CTRLALMOX == 'S' ? true : false;
            IDUTILLCESTQ = CTRLLOCAL == 'S' ? true : false;

            almoxField.clearValue();

            if (IDUTILALMOX) {
                almoxField.readOnly = false;
                almoxField.validations = { "required": { "message": "Campo Obrigatório" } };
                if (IDUTILLCESTQ) {
                    LocalField.readOnly = false;
                    LocalField.validations = { "required": { "message": "Campo Obrigatório" } };
                }
            }
            else {
                delete almoxField.validations;
                almoxField.readOnly = true;
                almoxField.clearValue();
            }
            almoxField.reload();
            this.onChangeAlmox(widget);
        });
    };

    this.onChangeAlmox = function(widget) {
        const LocalField = widget.getField('DSLOCALESTOQ');
        let { CDALMOXARIFE, CDLOCALESTOQ } = widget.currentRow;

        LocalField.setValue(' ');

        if (IDUTILLCESTQ && CDALMOXARIFE) {
            LocalField.validations = { "required": { "message": "Campo Obrigatório" } };
            LocalField.readOnly = false;
            LocalField.clearValue();
        }
        else {
            LocalField.setValue(' ');
            CDLOCALESTOQ = ' ';
            delete LocalField.validations;
            LocalField.readOnly = true;
        }
        LocalField.reload();
        templateManager.updateTemplate();
    };

    this.onShowFields = function(widget) {
        const results = widget.dataSource.data;
        if (results instanceof Array) {
            const cdgrupprod = EstUtil.getFieldValue('CDGRUPPROD', 'mainWidget', true);

            Est70000_ResumoDeOperacoes_Service.getfieldsLabels(cdgrupprod).then(success => {
                const originalLabels = ["TITLE", "TOTAL"];
                const exceptionsFields = ["__isSelected"];
                let count = 1;

                for (var object in results[0]) {
                    this.createField(widget, object, success.dataset.subgrupprod, originalLabels, exceptionsFields);
                    count++;
                    if (count == results.length) widget.redraw();
                }
            });
        }
    };

    this.createField = function(widget, name, groups, originalLabels, exceptionsFields) {
        if (exceptionsFields.includes(name)) return;

        let label = originalLabels.includes(name) ? name : groups.filter(gp => gp.CDSUBGRPROD == name)[0].NMSUBGRPROD;
        let field;

        if (name === "TITLE") {
            field = {
                "name": ScreenService.i18n(name),
                "label": " ",
                "showOnForm": true,
                "showOnView": true,
                "showOnList": true,
                "readOnly": true,
                "template": "field/text-edit.html"
            };

        }
        else {
            field = {
                "name": ScreenService.i18n(name),
                "label": label,
                "showOnForm": true,
                "showOnView": true,
                "showOnList": true,
                "readOnly": true,
                "template": "field/text-edit.html",
                "align": "right",
                "filterProperties": {
                    "isVisible": false,
                    "showOnForm": false
                },
                "mask": {
                    "type": "float",
                    "params": {
                        "showSymbol": false,
                        "precision": 2,
                        "thousands": ".",
                        "decimal": ","
                    }
                }
            };
        }

        metaDataFactory.factoryField(field, widget, true);
    };

    this.clearResults = function(widget) {

        const originalFields = [
            "CDFILIAL",
            "NMFILIAL",
            "CDALMOXARIFE",
            "DSALMOXARIFE",
            "CDLOCALESTOQ",
            "DSLOCALESTOQ",
            "CDGRUPPROD",
            "NMGRUPPROD",
            "INTERVALO"
        ];

        widget.fields = widget.fields.filter(field => {
            return originalFields.includes(field.name);
        });
        widget.dataSource.data = [];
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Est70000_ResumoDeOperacoes_Controller', Est70000_ResumoDeOperacoes_Controller);
});
